controllers/disappeared_resource.py
from flask import Blueprint, redirect, url_for, render_template, abort, request, jsonify, flash, session

import services.disappeared_service as missing_service
import services.sighted_service as sighted_service
from configuration.loggin_configuration import logger
from parser.disappeared_parse import parse_request, parse_request_address, parse_missing

missing_controller = Blueprint('missing_controller', __name__)

PATH = "missing"


@missing_controller.route("/search", methods=['POST'])
def search():
    try:
        value = request.form.get("search")
        result = [parse_missing(item) for item in missing_service.search_all(value).json()["disappeared"]]

        return render_template("{}/index.html".format(PATH),
                               disappeared=result,
                               title="Pessoas desaparecidas",
                               pages=None,
                               selected=None,
                               name='missing')

    except Exception as e:
        logger.error("Error during search disappeared ", e)
        abort(500)


@missing_controller.route("/<page>")
def index(page=0):
    try:
        result = missing_service.pagination(page)

        pages = 0
        disappeared = []

        if result.status_code == 200:
            parse = result.json()
            pages = parse["pages"]
            disappeared = [parse_missing(item) for item in parse["disappeared"]]

        return render_template("{}/index.html".format(PATH),
                               disappeared=disappeared,
                               title="Pessoas desaparecidas",
                               pages=pages,
                               selected=int(page),
                               name='missing')

    except Exception as e:
        logger.error("Error during search disappeared ", e)
        abort(500)


@missing_controller.route("/sighted/<_id>/custom", methods=['GET'])
def sighted(_id):
    return render_template("{}/address.html".format(PATH), _id=_id, name="missing")


@missing_controller.route("/sighted/<_id>/custom", methods=['POST'])
def register_sighted(_id):
    try:
        address = parse_request_address(request)
        result = sighted_service.create_sighted(_id, address)

        if result.status_code == 201:
            flash("Registramos sua notificação, obrigado por colaborar.")
            return render_template("{}/address.html".format(PATH), _id=_id, name="missing")

        abort(result.status_code)

    except Exception as e:
        logger.error("Error during search disappeared ", e)
        abort(500)


@missing_controller.route("/maps", methods=['GET'])
def missing_maps():
    return render_template("{}/maps.html".format(PATH), title="Mapa de desaparecimento", name="map")


@missing_controller.route("/list-all-location", methods=['GET'])
def list_all_locations():
    return jsonify({"locations": missing_service.disappeared_geometry().json()["disappeared"]})


@missing_controller.route("/<_id>/create", methods=['GET'])
def create(_id):
    return render_template("{}/create.html".format(PATH), _id=_id, name="register")


@missing_controller.route("/register/<user_id>", methods=['POST'])
def register(user_id):
    try:
        disappeared = parse_request(request)

        result = missing_service.create_missing(user_id, disappeared)

        if result.status_code == 201:
            flash("Desaparecido cadastrado com sucesso!")
            return redirect(url_for('missing_controller.index', page=0))

        abort(result.status_code)

    except Exception as e:
        logger.error("Error during create missing", e)
        abort(500)


@missing_controller.route("/edit/<_id>", methods=["GET"])
def edit(_id):
    try:
        if 'user' in session and session['user']['_id'] == _id:
            missing = missing_service.get_by_user_id(_id)

            if missing.status_code == 200:
                return render_template("missing/edit.html", disappeared_list=missing.json()["disappeared"])

            if missing.status_code == 404:
                return redirect(url_for("missing_controller.create", _id=_id))

            if missing.status_code == 500:
                abort(500)

        abort(403)

    except Exception as e:
        logger.error("Error during search disappeared ", e)
        abort(500)


@missing_controller.route("/update/<_id>", methods=["POST"])
def update(_id):
    try:
        if 'user' in session:
            disappeared = parse_request(request)

            missing = missing_service.update(_id, disappeared)

            if missing.status_code == 200:
                flash("Informações do desaparecido atualizada com sucesso!")
                return redirect(url_for("missing_controller.edit", _id=disappeared["user_id"]))

            abort(missing.status_code)

        abort(403)

    except Exception as e:
        logger.error("Error during search disappeared ", e)
        abort(500)

templates/missing/address.html
{% extends "base.html" %}
{% block content %}
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header card-header-info">
                    <h4 class="card-title"><b>Informe o local onde você viu esta pessoa</b></h4>
                </div>
                <div class="card-body">
                    <form action="{{ url_for('missing_controller.register_sighted', _id= _id) }}" method="post">
                        <div class="row">
                            <div class="col-md-12" style="margin-top: 30px">
                                <input type="hidden" name="_id" value="{{ _id }}">
                            </div>
                            <div class="col-md-12">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Observação</label>
                                    <textarea rows="2" required="required" name="observation" class="form-control"></textarea>
                                </div>
                            </div>
                            <div class="col-md-12">
                                {% include "mapbox.html" %}
                            </div>
                        </div>
                        <div class="col-md-12">
                            <input type="submit" class="btn btn-info" value="Notificar"/>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

templates/missing/create.html
{% extends "base.html" %}
{% block content %}
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header card-header-info">
                    <h4 class="card-title"><b>Cadastro de desaparecido</b></h4>
                    <p class="card-title"><b>Todos os campos que possuem (*) são requeridos para o cadastro</b></p>
                </div>
                <div class="card-body">
                    <form action="{{ url_for('missing_controller.register', user_id= _id) }}" method="post"
                          enctype="multipart/form-data">
                        <div class="row">
                            <div class="col-md-4">
                                <div class="form-group">
                                    <div class="btn btn-info">
                                        <label for="input-file" class="button" style="color: white"> <i
                                                class="material-icons">camera_alt</i>
                                            Foto do desaparecido</label>
                                        <input type="file" required="required" id="input-file" name="file" value=""/>
                                        <span id='file-name'></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-4">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Nome *</label>
                                    <input type="text" required="required" name="name" class="form-control">
                                </div>
                            </div>
                            <div class="col-md-2">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Apelido</label>
                                    <input type="text" name="nickname" class="form-control">
                                </div>
                            </div>
                            <div class="col-md-2">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Nascimento *</label>
                                    <input type="text" required="required" data-mask="00/00/0000"
                                           data-mask-selectonfocus="true" name="birth_date" class="form-control date">
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Dia do desaparecimento *</label>
                                    <input type="text" required="required" data-mask="00/00/0000"
                                           data-mask-selectonfocus="true" name="date_of_disappearance"
                                           class="form-control date">
                                </div>
                            </div>
                            <div class="col-md-1">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Altura</label>
                                    <input type="text" data-mask="0.00"
                                           data-mask-selectonfocus="true" name="height"
                                           class="form-control">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Olhos *</label>
                                    <select name="eyes" class="form-control">
                                        <option value="green">Verde</option>
                                        <option value="blue">Azul</option>
                                        <option value="brown">Castanho</option>
                                        <option value="black">Pretos</option>
                                        <option value="dark_brown">Castanho Escuro</option>
                                    </select>
                                    <!--<input type="text" name="nickname" class="form-control">-->
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Cabelo *</label>
                                    <select name="hair" class="form-control">
                                        <option value="black">Preto</option>
                                        <option value="brown">Castanho</option>
                                        <option value="redhead">Ruivo</option>
                                        <option value="blond">Loiro</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Pele *</label>
                                    <select name="skin" class="form-control">
                                        <option value="white">Branco</option>
                                        <option value="black">Negro</option>
                                        <option value="brown">Pardo</option>
                                        <option value="yellow">Amarelo</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Sexo *</label>
                                    <select name="gender" class="form-control">
                                        <option value="male">Masculino</option>
                                        <option value="female">Feminino</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-12">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Roupa que vestia</label>
                                    <textarea name="clothes" class="form-control" maxlength="80" rows="2"></textarea>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-4">
                                <div class="form-group">
                                    <label class="bmd-label-floating">BO</label>
                                    <input type="text" name="event_report"
                                           class="form-control">
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Tatuagem</label>
                                    <input type="text" name="tattoo" class="form-control">
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group">
                                    <label class="bmd-label-floating">Cicatriz</label>
                                    <input type="scar" name="scar" class="form-control">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12" style="margin-top: 30px">
                                <input type="hidden" name="status" value="disappeared"/>
                                <h3 style="color: darkred">Local do desaparecimento</h3>
                            </div>
                            <div class="col-md-12">
                                {% include "mapbox.html" %}
                            </div>
                        </div>
                        <input type="hidden" name="user_id" value="{{ _id }}" />
                        <button type="submit" class="btn btn-info pull-right">Enviar</button>
                        <div class="clearfix"></div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <script>
        document.addEventListener("DOMContentLoaded", function () {
            document.getElementById("input-file").required = true;

            var $input = document.getElementById('input-file'),
                $fileName = document.getElementById('file-name');

            $input.addEventListener('change', function () {
                $fileName.textContent = this.value + ' tamanho ' + this.files[0].size / 1024 / 1024 + "MB";
            });

            $('.date').blur(function () {
                if (this.value.trim() != '') {
                    let val = this.value.split('/');
                    let date = new Date(val[2], parseInt(val[1]) - 1, val[0]);
                    let today = new Date();
                    if (date > today) {
                        demo.showNotification('top', 'right', 'A data que foi informada está acima da data de hoje', 2);
                        this.value = "";
                        this.focus();
                    }
                }
            });
        });
    </script>
{% endblock %}

templates/missing/index.html
{% extends "base.html" %}
{% block content %}

<div class="row">
    {% for d in disappeared %}

    {% include "missing/cards/simple.html" %}

    <div class="modal fade" id="{{d._id}}" tabindex="-1" role="dialog" aria-labelledby="{{d._id}}"
         aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Pessoa desaparecida</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    {% include "missing/cards/complete.html" %}
                </div>
                <div class="modal-footer">
                    <a href="{{ url_for('missing_controller.sighted', _id=d._id) }}"
                       class="btn avistado btn-info">Informe o Local</a>
                </div>
            </div>
        </div>
    </div>
    {% endfor %}
</div>
{% if pages %}
<div class="row">
    <nav>
        <ul class="pagination justify-content-center">
            <li class="page-item">
                <a class="page-link" href="{{url_for('missing_controller.index', page=0)}}">início</a>
            </li>
            {% for page in range(0, pages) %}
            <li class="page-item {{'active' if (selected == page) else ''}}">
                <a href="{{url_for('missing_controller.index', page=page)}}" class="page-link">{{ page }}</a>
            </li>
            {% endfor%}
            <li class="page-item">
                <a class="page-link" href="{{url_for('missing_controller.index', page=(pages-1))}}">fim</a>
            </li>
        </ul>
    </nav>
</div>
{% endif %}
{% endblock %}

templates/missing/maps.html
{% extends "base.html" %}
{% block content %}
<div class="row">
    <div class="col-md-12">
        O mapa de desaparecimento é o local onde você poderá verificar as regiões com maior índice de desaparecimento.
    </div>
    <div class="col-md-12">
        <div id="map" style='width: 100%; max-height: 500px'></div>
        <script>
            document.addEventListener("DOMContentLoaded", function () {

                const accessToken = 'pk.eyJ1IjoiZGVzYXBhcmVjaWRvc21lIiwiYSI6ImNqa3ZrYWdqcDBzMzUzcHBhdGhhdWp1YmEifQ.09Yj5rE71q2u_WGfPu3LFA'
                const center = [-47.9100981, -15.85144512]
                const features = [];

                $.getJSON("{{ url_for('missing_controller.list_all_locations') }}", function (data) {
                    $.each(data.locations, function (key, val) {
                        features.push({
                            "type": "Feature",
                            "properties": {
                                "description": `Quantidade ${val.quantity}`,
                            },
                            "geometry": {
                                "type": "Point",
                                "coordinates": val.geometry
                            }
                        });
                    });

                    let geojson = {
                        type: 'FeatureCollection',
                        features: features
                    };

                    setupMapBox(accessToken,center, "map", geojson, 3);
                });

            });
        </script>
    </div>
</div>
{% endblock %}